import com.cycling74.max.*;
import com.cycling74.msp.*;
import java.util.Random;


/*
*	copies random chunks of a buffer then pastes it back into the same
*   buffer creating a random cut up effect.
*   Leafcutter John 10th Jan 2012
*   www.leafcutterjohn.com
*/

public class chopUp extends MaxObject {
	
	String bufname = null;
	Random copyStart = new Random();
	Random copyLength = new Random();
	Random pasteStart = new Random();
	int maxChunkLength = 4410;
	

	float[] chunk; // somwhere to put our chunk when copying
	float[] samps; // the composite sample 


	
chopUp(Atom[] a) {
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL});
		createInfoOutlet(false);
		if (a.length>0) 
			set(a[0].toString());
	}
	
	public void set(String s) { 
		bufname = s;
	}
	

	public void  maxChunkSize(int i){ // set max chunk length
	maxChunkLength = i;
	}
	
	
// cut&paste begin...

	public void cutAndPaste(int noCp){
		
		samps = MSPBuffer.peek(bufname, 0); // get data from buffer

		for (int i = 0; i < noCp; i++){     // keeps track of how many cuts have been made
            
		copyChunk();                        // runs copy function
		pasteChunk();                       // runs paste function
		
	}

		MSPBuffer.poke(bufname, 0, samps);  // when all the copy/pates have happened spit the 
                                            // result of our cutting and pasting back into the max buffer
} // end cutAndPaste

	private void copyChunk(){ //start copyChunk
	
	
	int cl = copyLength.nextInt(maxChunkLength); 
	int cs = copyStart.nextInt(samps.length-cl);
	chunk =  new float[cl];

	for(int i = 0; i < cl; i++){
		
		chunk[i] = samps[i+cs];
		
		}
	} // end copyChunk

	private void pasteChunk(){ // start pasteChunk

	int ps = pasteStart.nextInt(samps.length - chunk.length);
	
	for(int i = 0; i < chunk.length;i++){
		
		samps[i+ps] = chunk[i];

		}
	} //end pasteChunk


}// end chopUp class






































